--#################################################################################################
-- 2025-05-20 08:43:26.581 MachineName:ViscosityLowell; ComputerBiosName:VISCOSITYLOWELL;  
-- ApplicationName: DBA | AppEmailGroup: lowell.izaguirre@viscosityna.com | ServerUptime[dd:hh:mm:ss]: 00:01:33:43
-- Cname: wks-lowell.workgroup,;  LoginName: VISCOSITYLOWELL\lowell Authorization Scheme: SQL viscositylowell
-- Context: ViscosityLowell,; Database:master; Version: [SQL 2022 || 16.0.4165.4] Developer Edition (64-bit)
--#################################################################################################
SET TRANSACTION ISOLATION LEVEL READ UNCOMMITTED;
GO
--desc: suite of tools to check SSRS
--#################################################################################################
-- Failed Reports
--#################################################################################################
SELECT '[Failed Reports]' AS [Failed Reports],
[ex].[Status] + ' Today' AS Focus,
  --@Layer AS ServerLayer,
  CONVERT(VARCHAR(128),@@SERVERNAME) AS ServerName,
  CONVERT(VARCHAR(128),DB_NAME()) AS DatabaseName,  
  a.name, 
  DATEDIFF(minute,[ex].TimeStart,[ex].TimeEnd) AS ElapsedTime,
  [ex].[Status],
  [ex].[RequestType],
  [ex].[Format],
  [ex].[Parameters],
  [ex].[ReportAction],
  [ex].[TimeStart],
  [ex].[TimeEnd]
FROM [ReportServer].dbo.[ExecutionLog2] ex
  INNER JOIN [ReportServer].[dbo].[Catalog] a
    ON ex.[ReportPath] = a.[Path]
WHERE 1=1
  AND [RequestType] ='Subscription'
  AND [TimeStart] > DATEADD(dd,-1,CONVERT(DATE,getdate()))
  AND [ex].[Status] <> 'rsSuccess' --'rsProcessingAborted'
 ORDER BY [ex].[TimeStart] DESC
 --select * from msdb.dbo.sysjobs where job_id = '5272D3E8-EF88-451A-858D-8A8D0DBD52AA'
 --#################################################################################################
 -- Recent Subscriptions
 --#################################################################################################
 
  SELECT '[Recent Subscriptions]' AS [Recent Subscriptions],
  'Currently ' + d.laststatus AS Focus,
     --'EXEC ReportServer.dbo.AddEvent @EventType=''TimedSubscription'', @EventData=''' + CAST(a.SubscriptionID AS VARCHAR(40)) + '''' AS ReportCommand
    'EXECUTE msdb.dbo.[sp_start_job] @job_name = ''' + b.name + ''';' AS JobName
   --, a.SubscriptionID
   , e.name
   ,CASE WHEN  DataSettings is not null Then 'Data Driven Subscription' ELSE ' Standard SubScription' END AS SubScriptionType
   --, e.path
   , d.description
   , d.laststatus
   , eventtype
   , LastRunTime
   , date_created
   , date_modified,
   DataSettings
FROM 
   [ReportServer].dbo.ReportSchedule a JOIN msdb.dbo.sysjobs b ON CONVERT(VARCHAR(50),a.ScheduleID) = b.name
   JOIN [ReportServer].dbo.ReportSchedule c ON b.name = CONVERT(VARCHAR(50),c.ScheduleID)
   JOIN [ReportServer].dbo.Subscriptions d ON c.SubscriptionID = d.SubscriptionID
   JOIN [ReportServer].dbo.Catalog e ON d.report_oid = e.itemid
WHERE LastRunTime>= CONVERT(date,getdate())
ORDER BY LastRunTime DESC