--desc: assumes the ApplicationErrorLog extended event, jobs and functionality is in place featuring RingBuffer; returns applciation errors ignored by the biz
--TRUNCATE TABLE [msdb].[dbo].[ApplicationErrorLog]
--EXECUTE msdb.dbo.sp_start_job @job_name='DBA_ApplicationErrors'


    DECLARE @ServerName VARCHAR(128)
    SELECT 
      @ServerName =      CONVERT(VARCHAR(128),prpz.value) --AS CName
    FROM [master].sys.[extended_properties] prpz
    WHERE prpz.class=0 
    AND prpz.name = 'Cname'
    SELECT @ServerName = ISNULL(@ServerName,CONVERT(VARCHAR(128),@@SERVERNAME))

DECLARE @Layer VARCHAR(30); SET  @Layer = '[CMSServerLayer]'
SELECT  
        @Layer AS ServerLayer,
        @ServerName AS CName,
        CONVERT(VARCHAR(128),@@SERVERNAME) AS ServerName,
        ApplicationErrorLogID,
        TS,
        DBName,
        Duplicates,
        Err_No,
        Err_Severity,
        REPLACE(REPLACE(Err_Message,CHAR(13),' '),CHAR(10),' ') AS Err_Message,
        UserID,
        spid,
        Hostname,
        REPLACE(REPLACE(DBCall,CHAR(13),' '),CHAR(10),' ') AS DBCall,
        AppName,
        Err_State,
        LastUpdated
        
FROM    [msdb].[dbo].[ApplicationErrorLog] WITH ( NOLOCK ) 
WHERE 1=1
AND DBCall <> 'sys.sp_MScdc_capture_job'
AND REPLACE(REPLACE(Err_Message,CHAR(13),' '),CHAR(10),' ') NOT IN( 'auto statistics internal','Incorrect syntax near the keyword ''SET''.')
AND REPLACE(REPLACE(Err_Message,CHAR(13),' '),CHAR(10),' ') NOT LIKE 'Invalid SPID%'
AND [AppName] <> 'Tanium Client'
AND (DBName = DB_NAME() OR DB_NAME() = 'master')
ORDER BY [TS] DESC